"use strict"
_ = require("lodash")
fs = require("fs")
debug = require("debug")("omg-webui:ziplogs")

module.exports = (req, res) ->
  walkSync = (dir, beginsWith) ->
    results = []
    allFiles = fs.readdirSync(dir)
    _.each allFiles, (file) ->
      stat = fs.statSync(dir + file)
      if stat and stat.isDirectory()
        return
      else
        results.push dir + file if beginsWith and file.lastIndexOf(beginsWith) > -1
        results.push dir + file unless beginsWith
        debug "found file " + JSON.stringify(file)
      return

    results

  filesFromData = walkSync("/data/")
  coreDumpFiles = walkSync("/usr/fb/bin/sipisdn/", "core")
  logFiles = [
    "/tmp/logs/webSyslog.olg",
    "/tmp/logs/capture.cap",
    "/var/log/webui.log",
    "/var/log/omgproducermanager.log"
  ]

  # Options -r recursive;  - redirect to stdout
  args = [
      "-r"
      "-"
  ]
  args = args.concat(filesFromData)
  args = args.concat(coreDumpFiles)
  args = args.concat(logFiles)
  spawn = require("child_process").spawn
  zip = spawn("zip", args)
  res.set "Content-Type", "application/zip"
  res.set "Content-Disposition", "attachment; filename=OMG_Export.zip"

  # Keep writing stdout to res
  zip.stdout.on "data", (data) ->
    res.write data
    return

  zip.stderr.on "data", (data) ->
    # Uncomment to see the files being added
    # console.log "zip stderr: " + data
    return

  # End the response on zip exit
  zip.on "exit", (code) ->
    if code isnt 0

      # res.statusCode = 500;
      console.log "zip process exited with code " + code
      res.end()
    else
      res.end()
