#!/bin/bash

. /tmp/cmdline

me=$(readlink -f $0)
BASE=$(dirname ${me})
featureversion=$(featureversion)

if test "$(lsb_release -is)" != "Ubuntu";then
    read -p "Wrong OS! Please download the Ubuntu update from http://www.ferrari-electronic.de. [Abort]" answer
    exit 2
fi

featureversion=$(featureversion)

if [ ! -z "${featureversion}" ]; then
    if [ -e /tmp/gateconfig.featureversion ]; then
        gateconfigversion=$(cat /tmp/gateconfig.featureversion)
        if [ -z "${gateconfigversion}" -o ${gateconfigversion} -lt ${featureversion} ]; then
            echo "***********************************************************************************"
            echo "* OfficeMaster GateConfiguration too old. Please download new version"
            echo "* http://www.ferrari-electronic.de/fileadmin/download_center/OfficeMasterHardware/Setup-OfficeMaster-Gate-Config.exe"
            echo "***********************************************************************************"
            read -p "OfficeMaster GateConfiguration too old. Please download new version. [Abort/Default=Abort]!" answer
            sleep 5
            echo "## Installation failed ## ..."
            echo "FLASH_FAILED" # Old gateConfig
            touch /tmp/flashfailed
            exit 1
        fi
    else
        if [ -e /var/config.active -o "${HISTFILE}" != "" ]; then
            echo "***********************************************************************************"
            echo "* OfficeMaster GateConfiguration too old. Please download new version"
            echo "* http://www.ferrari-electronic.de/fileadmin/download_center/OfficeMasterHardware/Setup-OfficeMaster-Gate-Config.exe"
            echo "***********************************************************************************"
            read -p "OfficeMaster GateConfiguration too old. Please download new version. [Abort/Default=Abort]!" answer
            sleep 5
            echo "## Installation failed ## ..."
            echo "FLASH_FAILED" # Old gateConfig
            touch /tmp/flashfailed
            exit 2
        fi
    fi
fi

deblist=$(find ${BASE} -name '*.deb');
if test -z "${deblist}"; then
    echo "No Packages found."
    exit 1
fi

if which wdstop >/dev/null; then
    echo "Stopping watchdog"
    wdstop
else
    echo "Error: wdstop not found!"
    echo "Login into gate and perform update by hand"
    exit 1
fi

if which omgstopall >/dev/null 2>/dev/null; then 
    omgstopall; 
fi

for i in ${deblist};do
    dpkg -i ${i} || exit 1
done

exit 0
